/**
 * @module dixim
 * @submodule common
 */
dixim.namespace('dixim.common');

/**
 * @module common
 * @submodule block-ui-view
 */

(function() {
var BlockUi;
var prototype;
var superConstructor;
var _ = dixim.ctt.ResourceBundle.get;
var $ = dixim.ctt.jQuery;

/**
 * @class BlockUi
 * @constructor
 * @param {Object} configs
 */
BlockUi = function(configs) {
    this._initialize(configs);
};

dixim.common.BlockUi = BlockUi;
prototype = BlockUi.prototype;
superConstructor = BlockUi.superConstructor;

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    configs = configs || {};

    this._setting = {}
    this._setting.message = configs.message || _('dialog_waiting_description');
    this._setting.css = {
        border: 'none',
        padding: '10px',
        backgroundColor: '#333',
        opacity: .5,
        color: '#fff',
    };
    this._setting.overlayCSS = {
        backgroundColor: '#000',
        opacity: 0.6,
    };
    this._blocking = false;
};

prototype.block = function(msg) {
    this._blocking = true;
    if (typeof msg !== 'undefined') this._setting.message = msg;
    setTimeout(dixim.proxy(function() {
        $.blockUI(this._setting);
    }, this), 10);
};

prototype.unblock = function() {
    if (!!!this._blocking) return;
    setTimeout(dixim.proxy(function() {
        $.unblockUI();
    }, this), 10);
    this._blocking = false;
};

}());
