/**
 * @module dixim
 * @submodule server
 */
dixim.namespace('dixim.server');

/**
 * @module server
 * @submodule activation-view
 */

(function() {
var ActivationView;
var prototype;
var superConstructor;
var _ = dixim.ctt.ResourceBundle.get;
var Event = dixim.event.Event;
var EventTarget = dixim.event.EventTarget;
var $ = dixim.ctt.jQuery;

/**
 * @class ActivationView
 * @constructor
 * @param {Object} configs
 */
ActivationView = function(configs) {
    EventTarget.call(this);
    this._initialize(configs);
};

dixim.inherit(ActivationView, EventTarget);
dixim.server.ActivationView = ActivationView;
prototype = ActivationView.prototype;
superConstructor = ActivationView.superConstructor;

var PREV = 'prev';

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    configs = configs || {};

    this._title = _('server_menu_activation');
};

/**
 * @method show
 */
prototype.show = function() {
    $('.rootPage').html([
        '<div class="contents" data-enhance="false">',
        '<h2 id="tit_page">', this._title, '</h2>',
        '<div class="contents_inner">',
        '<div class="dl_tbl">',
        '<dl>',
        '<dt id="auth_title">', '</dt>',
        '<dd>',
        '<input id="auth_val" type="text" class="form_block" readonly="readonly" />',
        '</dd>',
        '</dl>',
        '<dl>',
        '<dt id="auth_detail_title">', '</dt>',
        '<dd>',
        '<div id="auth_detail_val" class="boot_server_description_field" readonly="readonly">', '</div>',
        '</dd>',
        '</dl>',
        '</div>',
        '</div>',
        '</div>',
    ].join(''));

    $('.art_tit').text(this._title);
    $('.btn_prev').show().one('click', dixim.proxy(this._clickPrev, this));
};

/**
 * @method hide
 */
prototype.hide = function() {
    $('.rootPage').empty();
};

prototype.setValue = function(id, val, operation) {
    var selector = $(['#', id].join(''));

    if (operation == 'text') {
        selector.html(val);
    } else if (operation == 'val') {
        selector.val(val);
    }
};

prototype._clickPrev = function() {
    this.dispatchEvent(new Event(PREV));
};

}());
